Option Explicit

'Use a Potentiometer on ADC_Pin (set to be 14 here) to control the motor speed


#DEFINE DEBUGGING	= 1

Public Const ADC_Pin		as byte = 14


Public Sub Main()

	Dim Hertz 		as UnsignedInteger
	Dim Old_Hertz	as UnsignedInteger
	Dim Speed		as Single 
	Dim FHz			as Single
	
	Dim Counter 	as Integer
	Dim Avg 		as UnsignedLong
	   

	Call PutPin(ADC_Pin,BXInputTristate)
	
	'_______________________________________________________________
	'This is a necessary part of the PWM API
	IF (NOT PWMInitialize()) then
		Debug.print "Timer1 BUSY.  Nothing will work!"
	End If
	
	

	Old_Hertz = 9999
	DO
		'produce an H-Bridge PWM signal to control motor speed

		Avg = 0
		
		For Counter = 1 to 240
			Avg = Avg + CULng(GetADC(ADC_Pin))
		Next 'Counter
		
		Hertz = CUInt(Avg\240)			'this is now the ADC count

		Speed = CSng(Hertz)/ 1024.0		'range should be 0.0 to 1.0
										'use 1 higher than 1023 because F-PWM can not
										'run at absolute 100%  It screws up.

		
		If (Hertz <> Old_Hertz) Then
			Call HBridgeSetSpeed (1, Speed)
			Old_Hertz = Hertz
				
			#IFDEF DEBUGGING
				Debug.Print "ADC:  ";CStr(Hertz)
				Debug.Print "Speed:  ";CStr(Speed)
				Debug.Print "Freq:  ";CStr(PWMGetFreq)
				Debug.Print "Steps: ";cstr(PWMGetSteps)
				Debug.Print "Mode:  ";CStr(PWMGetMode)
				Debug.Print "Pre:   ";CStr(PWMGetPre)
				Debug.Print "PhaseA:";CStr(PWMGetPhase(1))
				Debug.Print "PhaseB:";CStr(PWMGetPhase(2))
				Debug.Print
			#ENDIf
		End If
	
	Loop
	
	'These are commented-out because this program will never reach these lines
	'but they demonstrate the proper usage
	
'	Call PWMDisable(1)	'Turns off this channel
'	Call PWMDisable(2)	'Turns off this channel
'	Call PWMUnInit()	'Necessary to release Timer 1
End Sub