'must be used in conjunction with the Hi_Res_PWM_API.Bas module

Private ServoMinCount 		as Single
Private ServoRangeCount 	as Single
Private ServoFullCount		as Single
'keep the count variables as singles to minumize rounding errors

public sub ServoInit()
	dim	Result		as Boolean
	dim	Prescaler	as UnsignedInteger
	Dim Freq		as Single
	Dim	Period		as Single
	Dim	Steps		as Single
	'_______________________________________________________________
	'This is a necessary part of the PWM API

	
	Prescaler = PWMSetFreq(50.0)
	'test Prescaler here to see if it was successful
	
	'get the actual frequency that is being used
	'it will be very close to 50.000Hz
	Freq = PWMGetFreq()
	Period = 1.0 / Freq
	
	ServoFullCount = CSng(PWMGetSteps())
	
	ServoMinCount = ServoFullCount / (1000.0 * Period)	'steps for 1mS pulse
	ServoRangeCount = ServoMinCount						'servo range is 1ms I.E. 1ms-2ms
	
	'in actual use these numbers can be s/w adjusted to suit the specific servo
	
End Sub


public Sub ServoSetPosition(ByVal Channel as Byte, ByVal ServoPos as Single)
	Dim	Position	As Single
	
	'range check ServoPos here (0.0-1.0)
	'Range check Channel here (1,2)
	'position is referenced to the full range of the timer
	
	'the servo counts need to be scaled to the full timer count
	Position = (ServoMinCount + (ServoRangeCount * ServoPos)) / ServoFullCount
	
	Call PWMEnable(Channel, Position, 0)	'use Normal phase (0)
	
End Sub
